<template>
  <div class="image-upload">
    <div class="mb-3">
      <div class="dropzone"></div>
    </div>
    <div class="mb-3">
      <button
        v-if="showTryAgainButton"
        class="btn btn-primary"
        type="button"
        aria-label="Try again"
        @click="onTryAgainClicked"
      >
        <i aria-hidden="true" class="bi bi-arrow-repeat"></i>
        Try again
      </button>
    </div>
  </div>
</template>

<script>
const MaxFileSizeMb = 6

import { ref, computed, onMounted } from 'vue'
import Dropzone from 'dropzone'
import { ObjectHelper, useNotification } from '../../core'
import { useAuth } from '../../identity'
import 'dropzone/dist/dropzone.css'

export default {
  name: 'ImageUpload',
  emits: ['imageUploaded', 'queueComplete'],
  props: {
    url: { type: String, required: true },
    allowMultiple: { type: Boolean, default: false },
    thumbnailWidth: { type: Number, default: 160 },
    acceptedFiles: { type: String, default: '.jpg,.png,.gif' },
  },
  setup(props, context) {
    const auth = useAuth()
    const notify = useNotification()

    const dropzone = ref(undefined)
    const thereWereErrors = ref(false)
    const showTryAgainButton = ref(false)
    const uploading = ref(false)
    const queued = ref(0)

    const dropzoneConfig = computed(() => {
      return {
        url: props.url,
        headers: auth.getAuthHeaders(),
        maxFiles: props.allowMultiple ? null : 1,
        maxFilesize: MaxFileSizeMb * 1024 * 1024,
        thumbnailWidth: props.thumbnailWidth,
        thumbnailHeight: props.thumbnailWidth,
        acceptedFiles: props.acceptedFiles,
      }
    })

    const optionsHash = computed(() => {
      return ObjectHelper.getHash(dropzoneConfig.value)
    })

    const onTryAgainClicked = () => {
      dropzone.value.removeAllFiles(true)
      showTryAgainButton.value = false
    }

    onMounted(() => {
      dropzone.value = new Dropzone('.dropzone', dropzoneConfig.value)

      dropzone.value.on('success', (file, image) => {
        context.emit('imageUploaded', image)
      })

      dropzone.value.on('queuecomplete', () => {
        context.emit('queueComplete')
        if (thereWereErrors.value) {
          showTryAgainButton.value = true
        }
      })

      dropzone.value.on('error', (file, message) => {
        notify.warning(`Error uploading ${file.filename}: ${message}`)
        thereWereErrors.value = true
      })
    })

    return {
      thereWereErrors,
      showTryAgainButton,
      uploading,
      queued,
      dropzoneConfig,
      optionsHash,
      onTryAgainClicked,
    }
  },
}
</script>

<style lang="scss">
@use '../../core/sass/vars';

.image-upload .dropzone {
  border: 4px dashed vars.$separatorColor;
  border-radius: vars.$galleryBorderRadius;
  background-color: tint(vars.$panelColor, 50%);
}

.dark .image-upload .dropzone {
  border-color: vars.$darkSeparatorColor;
  background-color: shade(vars.$darkPanelColor, 50%);
}
</style>
